;Copyright 1982 Infocom, Inc.  All rights reserved.

;Configuration Program for INTERLOGIC(tm) CP/M Files

;Configured for the LEAR SIEGLER ADM3

;This program should be edited to specify terminal and
;printer parameters for your CP/M system.  Edit this
;file, then assemble, load, and run the program.
;Complete documentation of the setup procedure will
;be found in your INTERLOGIC Reference Card.

;Terminal and printer specific parameters start at
;the label CPMCPL, about 20 lines below.  Nothing
;prior to that label should be altered.

ORG	100H		; Hex addr: 100

LPDL	EQU 100H
BDOS	EQU 05H
FCB	EQU 05CH

PSTRNG	EQU 9
OPEN	EQU 15
CLOSE	EQU 16
WRITES	EQU 21
SETDMA	EQU 26

START:	JMP CPMSTR		; Hex addr: 100-102 (C3 00 02)

;Setup parameters begin here.  Refer to the INTERLOGIC
;Reference Card for CP/M for complete documentation for
;editing this file.

CPMCPL: DB 79		;Characters/line (132 maximum) Hex addr: 03 (4F)
CPMLPP: DB 23		;Lines/screen (NOT including status line) Hex addr: 04 (17)
CPMFN:	DB 'ENCHANTE'
			;File name (DO NOT CHANGE THIS) Hex addr: 05-0C (ENCHANTE)
CPMCLF: DB 1		;1 if LF should print after CR on screen Hex addr: 0D-0E (01 01)
CPMLLF: DB 1		;1 if LF should print after CR on printer
CPMINV: DB 80H		;Number to add to ASCII value of characters
			;to have them print in inverse video.  Hex addr: 0F (80)
			;This is not applicable on many terminals.

;The following strings have a count field followed by up
;to 32 characters.
			;For VT100 terminals:
			;ESC[2J - erase the screen
			;ESC[t;br - define scrolloing region t=top line, b=bottom line
			;ESC[r;cH - cursor to row r col c
			;ESC[7m - reverse video characters
			;ESC[0m - normal characters
			;ESC[1m - bold characters
			;ESC[4m - underline characters
			;ESC[5m - blinking characters

INIT:	DB 18		;Initialize the terminal.  Hex addr: 10 (12)
			;Should position the cursor at the
			;lower left corner of the screen.
			;On terminals with the facility, a
			;scrolling region should be established
			;to include all but the top line on
			;the screen.  Also, clearing the screen
			;is desirable.
			; VT100	: 
			; DB 0E
			; then ESC[2JESC[1;23rESC[23;0H
	DB 1BH,5BH,32H,4AH,1BH,5BH,31H,3BH,32H,33H,72H,1BH,5BH,32H,33H,3BH,30H,48H; Hex addr: 11-22 (1B 5B 32 4A 1B 5B 31 3B 32 33 72 1B 5B 32 33 3B 30 48)

	DS 32-$+TINIT+1
TRESET: DB 0E		;Reset the terminal at end of game. Hex addr: 31 (0E)
			;For example, if a scrolling region
			;was established, reset it to include the
			;entire screen.  Clearing the screen is
			;NOT desirable.			
			; VT100: ESC[0;23rESC[23;0H
	DB 1BH,5BH,30H,3BH,32H,33H,72H,1BH,5BH,32H,33H,3BH,30H,48H ; Hex addr: 32-3F (1B 5B 30 3B 32 33 72 1B 5B 32 33 3B 30 48)
	DS 32-$+TRESET+1																																																																
BLINE:  DB 10		;Begin status line. Hex addr: 52 (0A)
			;Should move the cursor to the upper
			;left corner of the screen.  If at all
			;possible, should go into inverse video.
			; VT100: ESC[0;0HESC[7m
	DB 1BH,'=',32,32 ; Hex addr: 53-5C (1B 5B 30 3B 30 48 1B 5B 37 6D)

	DS 32-$+BLINE+1
ELINE:  DB 4		;End status line. Hex addr: 73 (0B)
			;Should move the cursor to the lower
			;left corner of the screen.  If status
			;line uses inverse video, this state
			;should be cleared.
			; VT100: ESC[23;0HESC[0m Hex addr: 74-7E (1B 5B 32 33 3B 30 48 1B 5B 30 6D)
	DB 1BH,'=',55,32

	DS 32-$+ELINE+1	
PINIT:  DB 0		;Printer initialization.
			;If any setup is required prior to
			;using scripting.

	DS 200H-$

;The setup parameters end at this point.  Nothing below this point
;should be changed for any reason.

CPMSTR: LXI SP,PDL+LPDL
	LDA CPMCPL
	CPI 132
	JC CPMST1
	MVI A,132
	STA CPMCPL
CPMST1:	LXI H,FCB
	MVI B,36
L1:	MVI M,0
	INX H
	DCR B
	JNZ L1
	LXI H,FCB+1
	LXI D,CPMFN
	MVI B,8
L2:	LDAX D
	MOV M,A
	INX H
	INX D
	DCR B
	JNZ L2
	LXI D,EXT
	MVI B,3
L3:	LDAX D
	MOV M,A
	INX H
	INX D
	DCR B
	JNZ L3

	MVI C,OPEN
	LXI D,FCB
	CALL BDOS
	INR A
	LXI D,BADOPN
	JZ FINIS

	LXI D,100H
	CALL WRITEB
	LXI D,180H
	CALL WRITEB

	MVI C,CLOSE
	LXI D,FCB
	CALL BDOS
	INR A
	LXI D,BADCLS
	JZ FINIS
	LXI D,OK
FINIS:	MVI C,PSTRNG
	CALL BDOS
	JMP 0

WRITEB: MVI C,SETDMA
	CALL BDOS
	MVI C,WRITES
	LXI D,FCB
	CALL BDOS
	ORA A
	RZ
	MVI C,CLOSE
	LXI D,FCB
	CALL BDOS
	LXI D,BADWRT
	JMP FINIS

BADOPN: DB 0DH,0AH,'CAN NOT OPEN FILE$'

BADCLS: DB 0DH,0AH,'ERROR ON FILE CLOSE$'

BADWRT: DB 0DH,0AH,'WRITE ERROR$'

OK:	DB 0DH,0AH,'CONFIGURATION PROGRAM FINISHED',0DH,0AH,'$'

EXT:	DB 'COM'
PDL:	DS LPDL


END START
